<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>Architecture &#8212; PyXB 1.2.6 documentation</title>
    
    <link rel="stylesheet" href="_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    './',
        VERSION:     '1.2.6',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true,
        SOURCELINK_SUFFIX: '.txt'
      };
    </script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Namespaces" href="arch_namespaces.html" />
    <link rel="prev" title="Release History" href="releases.html" /> 
  </head>
  <body role="document">
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="arch_namespaces.html" title="Namespaces"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="releases.html" title="Release History"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">PyXB 1.2.6 documentation</a> &#187;</li>
    <li style="margin-left: 20px">PyXB hosted on <a href="http://sourceforge.net/projects/pyxb"><img src="http://sflogo.sourceforge.net/sflogo.php?group_id=263147&amp;type=9"
    width="80" height="15" alt="Get PyXB: Python XML Schema Bindings at SourceForge.net. Fast, secure and Free Open Source software downloads"/></a></li>
     

      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="architecture">
<h1>Architecture<a class="headerlink" href="#architecture" title="Permalink to this headline">¶</a></h1>
<p>The architecture of PyXB requires an understanding of four models.
<a class="reference internal" href="arch_namespaces.html#namespaces"><span class="std std-ref">Namespaces</span></a> describe how objects are aggregated by name and kind.  The
<a class="reference internal" href="arch_component.html#componentmodel"><span class="std std-ref">Component Model</span></a> represents XML schema using the thirteen component
types defined in the <a class="reference external" href="http://www.w3.org/TR/xmlschema-1/">XML schema specification</a>.  The <a class="reference internal" href="arch_binding.html#bindingmodel"><span class="std std-ref">Binding Model</span></a> describes
how Python classes provide a Pythonic representation of the information
within specific components.  Finally, the <a class="reference internal" href="arch_content.html#contentmodel"><span class="std std-ref">Content Model</span></a> describes how
the component model of a specific schema supports translation between XML
documents and Python bindings.</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="arch_namespaces.html">Namespaces</a><ul>
<li class="toctree-l2"><a class="reference internal" href="arch_namespaces.html#namespace-category-maps">Namespace Category Maps</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch_namespaces.html#namespace-component-associations">Namespace Component Associations</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch_namespaces.html#namespace-resolution">Namespace Resolution</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch_namespaces.html#expanded-names">Expanded Names</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch_namespaces.html#namespace-context">Namespace Context</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch_namespaces.html#other-concepts">Other Concepts</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch_namespaces.html#storage-of-namespaces">Storage of Namespaces</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="arch_component.html">Component Model</a><ul>
<li class="toctree-l2"><a class="reference internal" href="arch_component.html#component-model-mix-ins">Component Model Mix-ins</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch_component.html#other-information">Other Information</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="arch_binding.html">Binding Model</a><ul>
<li class="toctree-l2"><a class="reference internal" href="arch_binding.html#supporting-capabilities">Supporting Capabilities</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch_binding.html#simple-type-definitions">Simple Type Definitions</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch_binding.html#complex-type-definitions">Complex Type Definitions</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch_binding.html#id5">Elements</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="arch_content.html">Content Model</a><ul>
<li class="toctree-l2"><a class="reference internal" href="arch_content.html#associating-xml-and-python-objects">Associating XML and Python Objects</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch_content.html#validating-the-content-model">Validating the Content Model</a></li>
</ul>
</li>
</ul>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="releases.html"
                        title="previous chapter">Release History</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="arch_namespaces.html"
                        title="next chapter">Namespaces</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/architecture.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="search.html" method="get">
      <div><input type="text" name="q" /></div>
      <div><input type="submit" value="Go" /></div>
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="arch_namespaces.html" title="Namespaces"
             >next</a> |</li>
        <li class="right" >
          <a href="releases.html" title="Release History"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">PyXB 1.2.6 documentation</a> &#187;</li>
    <li style="margin-left: 20px">PyXB hosted on <a href="http://sourceforge.net/projects/pyxb"><img src="http://sflogo.sourceforge.net/sflogo.php?group_id=263147&amp;type=9"
    width="80" height="15" alt="Get PyXB: Python XML Schema Bindings at SourceForge.net. Fast, secure and Free Open Source software downloads"/></a></li>
     

      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2017, Peter A. Bigot.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.5.5.
    </div>
  </body>
</html>